'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _import = require('lodash');

var _import2 = _interopRequireDefault(_import);

var promisify = function promisify(funcOrObject) {
  if (typeof funcOrObject === 'function') {
    return function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return new Promise(function (resolve, reject) {
        args.push(function (err) {
          for (var _len2 = arguments.length, rest = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
            rest[_key2 - 1] = arguments[_key2];
          }

          if (err) {
            reject(err);
          } else {
            resolve(rest.length === 1 ? rest[0] : rest);
          }
        });

        funcOrObject.apply(this, args);
      });
    };
  }

  if (typeof funcOrObject === 'object') {
    return _import2['default'].reduce(Object.keys(funcOrObject), function (acc, x) {
      acc[x] = promisify(funcOrObject[x]);
      return acc;
    }, {});
  }

  // Neither a func or an object, just return itself
  return funcOrObject;
};

exports['default'] = promisify;
module.exports = exports['default'];