'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _import = require('lodash');

var _import2 = _interopRequireDefault(_import);

var _childProcess = require('child_process');

var _childProcess2 = _interopRequireDefault(_childProcess);

exports['default'] = function () {
  var options = arguments[0] === undefined ? {} : arguments[0];

  var stdout = options.stdout && process.stdout ? process.stdout : [];
  var stderr = options.stderr && process.stderr ? process.stderr : [];

  return new Promise(function (resolve, reject) {
    var error = null;
    //console.log("Calling spawn! " + JSON.stringify(options));
    var proc = _childProcess2['default'].spawn(options.cmd, options.args, options.opts);

    proc.stdout.on('data', function (data) {
      if (_import2['default'].isArray(stdout)) {
        stdout.push(data.toString());
      } else {
        stdout.write(data.toString());
      }
    });

    proc.stderr.on('data', function (data) {
      if (_import2['default'].isArray(stderr)) {
        stderr.push(data.toString());
      } else {
        stderr.write(data.toString());
      }
    });

    proc.on('error', function (processError) {
      return error = error || processError;
    });

    proc.on('close', function (exitCode, signal) {
      var stdoutStr = _import2['default'].isArray(stdout) ? stdout.join('') : '';
      var stderrStr = _import2['default'].isArray(stderr) ? stderr.join('') : '';

      if (exitCode !== 0) {
        error = error || new Error('Process exited with code: ' + exitCode);
        error.stdout = stdoutStr;
        error.stderr = stderrStr;
      }

      var results = {
        stderr: stderrStr, stdout: stdoutStr,
        code: exitCode
      };

      if (error) {
        reject(error);
      } else {
        resolve(results);
      }
    });
  });
};

module.exports = exports['default'];